'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _createSyntheticFormEvent = require('../utils/createSyntheticFormEvent');

var _createSyntheticFormEvent2 = _interopRequireDefault(_createSyntheticFormEvent);

var _updateObjectData = require('../utils/updateObjectData');

var _updateObjectData2 = _interopRequireDefault(_updateObjectData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  name: _react.PropTypes.string.isRequired,
  formData: _react.PropTypes.object,
  formMeta: _react.PropTypes.object,
  onChange: _react.PropTypes.func
};

var getTarget = function getTarget(name, value) {
  return {
    name: name,
    value: value
  };
};

var updateData = function updateData(name, data, value) {
  return (0, _updateObjectData2.default)(data, { target: getTarget(name, value) });
};

var handleChange = function handleChange(name, props) {
  return function (evt) {
    var event = (0, _createSyntheticFormEvent2.default)(evt);
    event.formData = updateData(name, props.formData, event.formData);
    event.formMeta = updateData(name, props.formMeta, event.formMeta);
    event.target = getTarget(name, (0, _get2.default)(event.formData, name));
    return props.onChange(event);
  };
};

var branch = function branch() {
  return function (Component) {

    var defaultProps = {
      formData: {},
      formMeta: {}
    };

    var BranchedForm = function (_React$Component) {
      _inherits(BranchedForm, _React$Component);

      function BranchedForm() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, BranchedForm);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = BranchedForm.__proto__ || Object.getPrototypeOf(BranchedForm)).call.apply(_ref, [this].concat(args))), _this), _this.getBranchData = function (key) {
          return (0, _get2.default)(_this, ['props', key, _this.props.name], {});
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(BranchedForm, [{
        key: 'render',
        value: function render() {
          var formData = this.getBranchData('formData');
          var formMeta = this.getBranchData('formMeta');

          return _react2.default.createElement(Component, _extends({}, this.props, {
            formData: formData,
            formMeta: formMeta,
            onChange: handleChange(this.props.name, this.props)
          }));
        }
      }]);

      return BranchedForm;
    }(_react2.default.Component);

    BranchedForm.propTypes = propTypes;
    BranchedForm.defaultProps = defaultProps;
    return BranchedForm;
  };
};

exports.default = branch;