'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  name: _react.PropTypes.string.isRequired,
  defaultValue: _react.PropTypes.any,
  disabled: _react.PropTypes.bool,
  onChange: _react.PropTypes.func,
  onToggle: _react.PropTypes.func,
  value: _react.PropTypes.any
};

var defaultProps = {
  defaultValue: ''
};

var propKeys = Object.keys(propTypes);

var formControl = function formControl(Element) {

  !(typeof Element === 'function' || typeof Element === 'string') ? process.env.NODE_ENV !== 'production' ? (0, _invariant2.default)(false, '\n    Missing or invalid argument 1 for "formControl".\n    Expects one of string:["input", "textarea"] or React Element.\n    "' + Element + '" given\n    ') : (0, _invariant2.default)(false) : void 0;

  var Control = function (_React$Component) {
    _inherits(Control, _React$Component);

    function Control() {
      var _ref;

      var _temp, _this, _ret;

      _classCallCheck(this, Control);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Control.__proto__ || Object.getPrototypeOf(Control)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
        value: void 0
      }, _this.componentWillMount = function () {
        _this.setState({ value: _this.props.value });
      }, _this.shouldComponentUpdate = function (nextProps, nextState) {
        return !(0, _isEqual2.default)(_this.props, nextProps) || !(0, _isEqual2.default)(_this.state, nextState);
      }, _this.componentWillReceiveProps = function (nextProps) {
        if (nextProps.value !== _this.state.value) {
          _this.setState({ value: nextProps.value });
        }
      }, _this.getValue = function () {
        if (typeof _this.state.value === 'undefined') {
          return _this.props.defaultValue;
        }
        return _this.state.value;
      }, _this.handleChange = function (evt) {
        if (!_this.props.disabled) {
          var handler = _this.props.onChange || _this.props.onToggle;
          _this.setState({ value: evt.target.value });
          handler(evt);
        }
      }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Control, [{
      key: 'render',
      value: function render() {
        var props = (0, _omit2.default)(this.props, propKeys);

        return _react2.default.createElement(Element, _extends({}, props, {
          disabled: this.props.disabled,
          name: this.props.name,
          onChange: this.handleChange,
          value: this.getValue()
        }));
      }
    }]);

    return Control;
  }(_react2.default.Component);

  Control.propTypes = propTypes;
  Control.defaultProps = defaultProps;
  return Control;
};

exports.default = formControl;