'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _createSyntheticFormEvent = require('../utils/createSyntheticFormEvent');

var _createSyntheticFormEvent2 = _interopRequireDefault(_createSyntheticFormEvent);

var _FormContainer = require('../utils/FormContainer');

var _FormContainer2 = _interopRequireDefault(_FormContainer);

var _listActions = require('../utils/listActions');

var _listActions2 = _interopRequireDefault(_listActions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  name: _react.PropTypes.string.isRequired,
  formData: _react.PropTypes.object,
  formMeta: _react.PropTypes.object,
  onChange: _react.PropTypes.func
};

var handleChange = function handleChange(name, props) {
  return function (idx) {
    return function (evt) {
      var event = (0, _createSyntheticFormEvent2.default)(evt);
      event = _listActions2.default.change(idx, name, props, event);
      return props.onChange(event);
    };
  };
};

var handleAdd = function handleAdd(name, props) {
  return function () {
    var position = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'after';
    return function () {
      var event = (0, _createSyntheticFormEvent2.default)();
      event = _listActions2.default.add(position, name, props, event);
      return props.onChange(event);
    };
  };
};

var handleRemove = function handleRemove(name, props) {
  return function (idx) {
    return function () {
      var event = (0, _createSyntheticFormEvent2.default)();
      event = _listActions2.default.remove(idx, name, props, event);
      return props.onChange(event);
    };
  };
};

var list = function list() {
  var Container = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _FormContainer2.default;
  return function (Component) {

    var defaultProps = {
      formData: {},
      formMeta: {}
    };

    var ListForm = function (_React$Component) {
      _inherits(ListForm, _React$Component);

      function ListForm() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, ListForm);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ListForm.__proto__ || Object.getPrototypeOf(ListForm)).call.apply(_ref, [this].concat(args))), _this), _this.getListData = function (key) {
          return (0, _get2.default)(_this, ['props', key, _this.props.name], []);
        }, _this.renderList = function (onAddHandler, onChangeHandler, onRemoveHandler) {
          var formData = _this.getListData('formData');
          var formMeta = _this.getListData('formMeta');

          return formData.map(function (entry, idx) {
            return _react2.default.createElement(Component, {
              key: idx,
              name: idx,
              formData: (0, _get2.default)(formData, idx, {}),
              formMeta: (0, _get2.default)(formMeta, idx, {}),
              onChange: onChangeHandler(idx),
              onRemove: onRemoveHandler(idx)
            });
          });
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(ListForm, [{
        key: 'render',
        value: function render() {
          var onAddHandler = handleAdd(this.props.name, this.props);
          var onChangeHandler = handleChange(this.props.name, this.props);
          var onRemoveHandler = handleRemove(this.props.name, this.props);

          return _react2.default.createElement(
            Container,
            {
              onAdd: onAddHandler,
              onRemove: onRemoveHandler
            },
            this.renderList(onAddHandler, onChangeHandler, onRemoveHandler)
          );
        }
      }]);

      return ListForm;
    }(_react2.default.Component);

    ListForm.propTypes = propTypes;
    ListForm.defaultProps = defaultProps;
    return ListForm;
  };
};

exports.default = list;