'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _createSyntheticFormEvent = require('../utils/createSyntheticFormEvent');

var _createSyntheticFormEvent2 = _interopRequireDefault(_createSyntheticFormEvent);

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  onChange: _react.PropTypes.func,
  onError: _react.PropTypes.func
};

var applySideEffects = function applySideEffects(sideEffects, evt, props) {
  return sideEffects.reduce(function (p, fn) {
    return p.then(function (event) {
      return fn(event, props);
    });
  }, Promise.resolve(evt));
};

var handleChange = function handleChange(sideEffects) {
  return function (props) {
    return function (evt) {
      var event = (0, _createSyntheticFormEvent2.default)(evt);

      applySideEffects(sideEffects, event, props).then(function (event) {
        return props.onChange(event);
      }).catch(function (err) {
        return props.onError(err, _constants2.default.SIDE_EFFECTS_ERROR);
      });
    };
  };
};

var withSideEffects = function withSideEffects() {
  var sideEffects = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return function (Component) {

    !Array.isArray(sideEffects) ? process.env.NODE_ENV !== 'production' ? (0, _invariant2.default)(false, '\n    Missing or invalid argument 1 for "withSideEffects".\n    Expects an argument 1 of type "array". "' + (typeof sideEffects === 'undefined' ? 'undefined' : _typeof(sideEffects)) + '" given.\n    ') : (0, _invariant2.default)(false) : void 0;

    var onChangeHandler = handleChange(sideEffects);

    var FormWithSideEffects = function (_React$Component) {
      _inherits(FormWithSideEffects, _React$Component);

      function FormWithSideEffects() {
        _classCallCheck(this, FormWithSideEffects);

        return _possibleConstructorReturn(this, (FormWithSideEffects.__proto__ || Object.getPrototypeOf(FormWithSideEffects)).apply(this, arguments));
      }

      _createClass(FormWithSideEffects, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(Component, _extends({}, this.props, {
            onChange: onChangeHandler(this.props)
          }));
        }
      }]);

      return FormWithSideEffects;
    }(_react2.default.Component);

    FormWithSideEffects.propTypes = propTypes;
    return FormWithSideEffects;
  };
};

exports.default = withSideEffects;