'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutabilityHelper = require('immutability-helper');

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  formData: _react.PropTypes.object,
  formMeta: _react.PropTypes.object,
  onChange: _react.PropTypes.func
};

var defaultProps = {
  formData: {},
  formMeta: {},
  onChange: _noop2.default
};

var withState = function withState() {
  var defaultConfig = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return function (Component) {

    var config = _extends({
      formData: {},
      formMeta: {},
      shouldComponentUpdate: null
    }, defaultConfig);

    var ComponentWithState = function (_React$Component) {
      _inherits(ComponentWithState, _React$Component);

      function ComponentWithState() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, ComponentWithState);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ComponentWithState.__proto__ || Object.getPrototypeOf(ComponentWithState)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
          formData: {},
          formMeta: {}
        }, _this.componentWillMount = function () {
          _this.setState({
            formData: _extends({}, config.formData, _this.props.formData),
            formMeta: _extends({}, config.formMeta, _this.props.formMeta)
          });
        }, _this.shouldComponentUpdate = function (nextProps, nextState) {
          if (config.shouldComponentUpdate) {
            return config.shouldComponentUpdate(nextProps, nextState);
          }

          return !(0, _isEqual2.default)(_this.props, nextProps) || !(0, _isEqual2.default)(_this.state, nextState);
        }, _this.componentWillReceiveProps = function (nextProps) {
          _this.setState({
            formData: _this.refreshData('formData', nextProps),
            formMeta: _this.refreshData('formMeta', nextProps)
          });
        }, _this.refreshData = function (key, nextProps) {
          return (0, _immutabilityHelper2.default)(nextProps[key], {
            $merge: (0, _get2.default)(_this, ['state', key], {})
          });
        }, _this.handleChange = function (syntheticFormEvent) {
          syntheticFormEvent.removeEventActions();

          _this.setState({
            formData: _extends({}, syntheticFormEvent.formData),
            formMeta: _extends({}, syntheticFormEvent.formMeta)
          }, function () {
            _this.props.onChange(syntheticFormEvent);
          });
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(ComponentWithState, [{
        key: 'render',
        value: function render() {
          return _react2.default.createElement(Component, _extends({}, this.props, {
            formData: this.state.formData,
            formMeta: this.state.formMeta,
            onChange: this.handleChange
          }));
        }
      }]);

      return ComponentWithState;
    }(_react2.default.Component);

    ComponentWithState.propTypes = propTypes;
    ComponentWithState.defaultProps = defaultProps;
    return ComponentWithState;
  };
};

exports.default = withState;