'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _getDataFromKey = require('../utils/getDataFromKey');

var _getDataFromKey2 = _interopRequireDefault(_getDataFromKey);

var _constants = require('./constants');

var _constants2 = _interopRequireDefault(_constants);

var _withSideEffects = require('./withSideEffects');

var _withSideEffects2 = _interopRequireDefault(_withSideEffects);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  formMeta: _react.PropTypes.object,
  onError: _react.PropTypes.func
};

var defaultProps = {
  onError: _noop2.default
};

var applyValidations = function applyValidations(rules, formData) {
  return rules.reduce(function (p, fn) {
    return p.then(function (err) {
      return fn(err, formData);
    });
  }, Promise.resolve(void 0));
};

var getValidator = function getValidator(rules) {
  return function (event, props) {
    var formData = event.formData;
    var formMeta = event.formMeta;

    return applyValidations(rules, formData).then(function (err) {
      formMeta.errors = err;
      event.formMeta = formMeta;
      return event;
    }).catch(function (err) {
      return props.onError(err, _constants2.default.VALIDATION_ERROR);
    });
  };
};

var withValidation = function withValidation() {
  var rules = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  return function (Component) {
    !Array.isArray(rules) ? process.env.NODE_ENV !== 'production' ? (0, _invariant2.default)(false, '\n    Missing or invalid argument 1 for "withValidation".\n    Expects an argument 1 of type "array". "' + (typeof rules === 'undefined' ? 'undefined' : _typeof(rules)) + '" given.\n    ') : (0, _invariant2.default)(false) : void 0;

    var validator = getValidator(rules);
    var AppliedComponent = (0, _withSideEffects2.default)([validator])(Component);

    var ComponentWithValidation = function (_React$Component) {
      _inherits(ComponentWithValidation, _React$Component);

      function ComponentWithValidation() {
        _classCallCheck(this, ComponentWithValidation);

        return _possibleConstructorReturn(this, (ComponentWithValidation.__proto__ || Object.getPrototypeOf(ComponentWithValidation)).apply(this, arguments));
      }

      _createClass(ComponentWithValidation, [{
        key: 'render',
        value: function render() {
          var errors = (0, _get2.default)(this.props, 'formMeta.errors');

          return _react2.default.createElement(AppliedComponent, _extends({}, this.props, {
            getFormError: (0, _getDataFromKey2.default)(errors)
          }));
        }
      }]);

      return ComponentWithValidation;
    }(_react2.default.Component);

    ComponentWithValidation.propTypes = propTypes;
    ComponentWithValidation.defaultProps = defaultProps;
    return ComponentWithValidation;
  };
};

exports.default = withValidation;